// Intel high performance time method H-file

#ifndef IntelHPT
#define IntelHPT 1

// Define the clock frequency  (1.9GHz in this example)
#define MY_CPU_CLOCK 2000682000 

// Define the size of the time value
typedef unsigned long long int rdtsc_time;

///////////////////////////////////////////////////////////////
// Assembly routine used to read the high precision timer
///////////////////////////////////////////////////////////////
__inline__ rdtsc_time rdtsc()
{
   rdtsc_time x;
   __asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
   return x;
}

///////////////////////////////////////////////////////////////
// Routine to show duration stats
///////////////////////////////////////////////////////////////
void show_rdtsc_stats( rdtsc_time time0, rdtsc_time time1 );

#endif
